// numbertoken.hh
// number token class
// Kevin Puckett Albrecht
// Rev 4
// 20 March 2000 - 27 June 2000
//
// must define: GLOBAL_MANTISSA_SIZE

#ifndef NUMBERTOKEN_HH
#define NUMBERTOKEN_HH

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //
#include <string.h>
#include <stdlib.h>
#include <math.h>

// Local //
#include "k_string.hh"
#include "token.hh"
#include "inbuffer.hh"
#include "error.hh"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

class NumberToken : public Token
{
  public:
    NumberToken ()
    {
      code = codeNumber;
    }
    virtual void Get ();
    virtual bool IsDelimiter () const {return false;}
};

//// Get ////
void NumberToken::Get ()
{
  int nPos = 0;
  int nMantissaLen = -1;
  //REMOVED// val.type = tInt; // assume the value is an int

  buffer[nPos] = gpBuffer->Get ();
  gpBuffer->Seek ();

  while (k_inSet (gpBuffer->Get(), "1234567890."))
  {
    if (nMantissaLen > -1) // if currently in mantissa, increase mantissa length
    {
      nMantissaLen++;
    }
    if (gpBuffer->Get() == '.')
    {
      //REMOVED// val.type = tRat; // type must be rat
      nMantissaLen++;
    }
    buffer[++nPos] = gpBuffer->Get ();
    gpBuffer->Seek ();
  }

  // Fill any empty mantissa places with zeros //
  if (nMantissaLen > -1)
  {
    while (nMantissaLen < GLOBAL_MANTISSA_SIZE)
    {
      nMantissaLen++;
      buffer[++nPos] = '0';
    }
  }

  // End string //
  buffer[++nPos] = 0;

  //NOTE: the constant specifier maybe should be true?//
  SetContent (tValue, false, buffer, 0);
}

#endif